/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.hunter_a;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.UT2004Navigation;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "shootPlayer", description = "Shoot Player.")
public class ShootPlayer extends StateAction<HunterContext> {

    public ShootPlayer(HunterContext ctx) {
        super("shootPlayer", ctx);
    }
	
	@Override
	public void init(VariableContext vc) {
		
	}

	@Override
	public ActionResult run(VariableContext vc) {
		
		Player p = ctx.getPlayers().getNearestVisiblePlayer();
		
		ctx.getShoot().shoot(p);
		
		if (ctx.getInfo().getLocation().getDistance(p.getLocation()) > UT2004Navigation.AT_PLAYER*5)
			ctx.getMove().moveTo(p);
		
		return ActionResult.RUNNING;
	}

	@Override
	public void done(VariableContext vc) {
		ctx.getShoot().stopShooting();
	}

}
