/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.hunter_a;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "hasLoadedWeapon", description = "Do I have loaded weapon?")
public class HasLoadedWeapon extends StateSense<UT2004Context, Boolean> {

    public HasLoadedWeapon(UT2004Context ctx) {
        super("hasLoadedWeapon", ctx);
    }

    @Override
    public Boolean query(VariableContext params) {        
        return ctx.getWeaponry().hasLoadedWeapon();
    }
}
