/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.hunter_a;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.agent.module.utils.TabooSet;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "shootAndRun", description = "Shoot Player while running for healthpack.")
public class ShootAndRun extends CollectMedikits {
	

    public ShootAndRun(HunterContext ctx) {
        super(ctx);
    }
	
	@Override
	public void init(VariableContext vc) {
		tabooItems = new TabooSet<Item>(ctx.getBot());
	}

	@Override
	public ActionResult run(VariableContext vc) {
		
		Player p = ctx.getPlayers().getNearestVisiblePlayer();
		
		if (p != null) ctx.getShoot().shoot(p);

		super.run(vc);
		
		return ActionResult.RUNNING;
	}

	@Override
	public void done(VariableContext vc) {
		ctx.getShoot().stopShooting();
	}

}